#ifndef VL53L1_PLATFORM_USER_DATA_H
#define VL53L1_PLATFORM_USER_DATA_H

#include "vl53l1_def.h"

#define VL53L1DevStructGetLLDriverHandle(Dev)  (&Dev->Data.LLData)
#define VL53L1DevStructGetLLResultsHandle(Dev) (&Dev->Data.llresults)

#define VL53L1DevDataGet(Dev, field)       (Dev->Data.field)
#define VL53L1DevDataSet(Dev, field, data) ((Dev->Data.field) = (data))

typedef struct {
    uint8_t *TxData;
    uint8_t *RxData;
    uint16_t TxSize;
    uint16_t RxSize;
} VL53L1_Dev_Xfer_Desc_t;

typedef VL53L1_Error (*VL53L1_Delay_Us_t)(void *pdev, uint32_t usec);
typedef VL53L1_Error (*VL53L1_Delay_Ms_t)(void *pdev, uint32_t msec);
typedef VL53L1_Error (*VL53L1_I2C_Xfer_t)(void *pdev, VL53L1_Dev_Xfer_Desc_t *desc);

typedef struct {
    VL53L1_Delay_Us_t Delay_Us;
    VL53L1_Delay_Ms_t Delay_Ms;
    VL53L1_I2C_Xfer_t I2C_Xfer;
} VL53L1_Dev_Ops_t;

typedef struct {
    VL53L1_DevData_t Data;

    VL53L1_Dev_Ops_t Ops;
    void            *OpsData;
} VL53L1_Dev_t;

typedef VL53L1_Dev_t *VL53L1_DEV;

#endif  // VL53L1_PLATFORM_USER_DATA_H
