#include "app_sensors_impl.h"

#define APP_I2C_READ(addr)  ((addr << 1U) | 0x01U)
#define APP_I2C_WRITE(addr) ((addr << 1U) & (~0x01U))

ims_ret_t app_sensors_i2c_xfer(void *pdev, ims_i2c_xfer_desc_t *xfer) {
    app_sensors_impl_t *impl = pdev;

    HAL_StatusTypeDef ret;

    if (xfer->tx_size) {
        ret = HAL_I2C_Master_Transmit(impl->hi2c, APP_I2C_WRITE(impl->dev_addr), xfer->tx_data, xfer->tx_size, 1000);
        if (ret != HAL_OK) {
            return IMS_FAIL;
        }
    }

    if (xfer->rx_size) {
        ret = HAL_I2C_Master_Receive(impl->hi2c, APP_I2C_READ(impl->dev_addr), xfer->rx_data, xfer->rx_size, 1000);
        if (ret != HAL_OK) {
            return IMS_FAIL;
        }
    }

    return IMS_SUCCESS;
}

ims_ret_t app_sensors_delay(void *pdev, uint32_t delay_msec) {
    HAL_Delay(delay_msec);

    return IMS_SUCCESS;
}